import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.io.StringReader;
import java.io.StringWriter;
import java.net.Socket;

class XMLSocketThread implements Runnable {
	private Thread _thisThread;
	private Socket _socket;
	private int POOL_LEN = 200;
	private int _pool_len;
  
  private byte[] _pool = new byte[POOL_LEN];
  

  /**
   * socketւ̏owriter
   *
   */
  private PrintWriter _writer;


  /**
   * socket̓ǂݏoXg[
   */
  private InputStream _instream;

  /**
   * RXgN^
   */
  protected XMLSocketThread( Socket socket ) throws IOException {
	  super();
	  _socket = socket;
	  _writer = new PrintWriter(new BufferedOutputStream(_socket.getOutputStream()));
	  _instream = _socket.getInputStream();
  }

  public void start() {
  	try {
	    _thisThread = new Thread(this);
	    _thisThread.start();
  	} catch (Exception ex) {
  		ex.printStackTrace();
  	}
  }

  public void stop() {
    _thisThread = null;
  }

  public void run()  {
    Thread curThread = Thread.currentThread();
    try {
      while (_thisThread == curThread) {
        boolean cnt = read();
      }
    } catch (Exception ex) {
      ex.printStackTrace();
    }
    System.out.println("Disconnected");
  }
  
  void receive() throws Exception{
  	String str = new String(_pool, 0, _pool_len, "UTF-8");
  System.out.println("receive: " + str);
   	str = "<resp_info resp_str=" + (str.substring(21)).replace('"', '\'') + "\0";   	
  System.out.println("receive: " + str);	
	OutputStreamWriter osw = new OutputStreamWriter(_socket.getOutputStream(), "UTF-8");
	osw.write(str);
   	osw.flush();
  }


  /**
   * _socketmsgށB
   * Flash5̋KōŌ#0tAmɏoflushsȂB
   *
   * @param  msg  String  XML
   */
  protected void write( String msg ) {
    _writer.write(msg);
    _writer.write(0);
    _writer.flush();
  }


 	private int BUFF_LEN = 200;
  /**
   * _socket當ǂݍށBǂݍ񂾕͍ŏI#0tĂ̂ŁAKvB
   *
   * @return  String  XML
   */
  protected boolean read() {
    boolean res = true;
    try {
	  byte[] buf = new byte[BUFF_LEN];
      int len = _instream.read(buf);
			
		if (len > 0) {
			for (int idx =0; idx < len; idx++) { 
	      	byte ch = buf[idx];
	       	if (ch != 0) {
		   		_pool[idx] = buf[idx];
		   		_pool_len = idx + 1;
		   	} else {
		   		receive();
		   		_pool = new byte[POOL_LEN];
		   	}
		}
			res = true;
		} else {
			res = false;
		}
    } catch (IOException ex) {
      System.out.println("NCAgbZ[Ws");
    } finally {
      return res;
    }
  }

  public String getHostInfo() {
    return _socket.getInetAddress().getHostAddress() + ":" + _socket.getPort();
  }

}
