function ASX_chkNull(val) {
	if (val == null) {
		return "";
	} else {
		return val;
	}
}
function ASX_inArray(ary, val) {
	if (val == null || val == "") { return false; }
	if (ary.toString().indexOf(String(val),  0) == -1) {
		return false;
	} else {
		return true;
	}
}

function ASX_Unmarshaler() {
	this.source = null;
}
ASX_Unmarshaler.prototype.setSource = function(aSrcXml) {
	this.srcXml = aSrcXml;
}
ASX_Unmarshaler.prototype.unmarshal = function() {
	return this.unmarshal_node(this.srcXml.firstChild);
}
ASX_Unmarshaler.prototype.unmarshal_node = function (baseNode) {
	var ASX_SUFFIX = "$";

	var baseObj = ASX_obj_factory(baseNode.nodeName);
	for (var pAttr in baseNode.attributes) {
		baseObj[pAttr + ASX_SUFFIX] = baseNode.attributes[pAttr];
	}
	if (baseNode.hasChildNodes()) {
		var subNode = baseNode.firstChild;
		var subObj = null;
		do {
			subObj = this.unmarshal_node(subNode);
			if (subNode.nodeType == 3) {
				baseObj["txt"] = subNode.nodeValue; 
			} else if (ASX_inArray(baseObj.uni_elems, subNode.nodeName)) {
				baseObj[subNode.nodeName + ASX_SUFFIX] = subObj;
			} else {
				eval("baseObj.add_" + subNode.nodeName)(subObj);
			}
			subNode = subNode.nextSibling;
		} while (subNode)
	}
	return baseObj;
}

function ASX_Marshaler() {
	this.srcObj = null;
	this.rootNode = null;
}
ASX_Marshaler.prototype.setRootInfo = function(aSrcObj, aNodeTxt) {
	this.srcObj = aSrcObj;
	this.rootNode = aNodeTxt;
}
ASX_Marshaler.prototype.marshal = function() {
	return new XML(this.marshal_node(this.srcObj, this.rootNode));
}
ASX_Marshaler.prototype.marshal_node = function (aObj, aNode) {
	var ASX_SUFFIX = "$";
	
	/* create node */
	var rtxt = '<' + aNode;
	/* handle attributes */
	var aAttr = null;
	for (var i=0; i<aObj.attrs_seq.length-1; i++) {		// ŏIvfdummy
		aAttr = aObj.attrs_seq[i];
		rtxt += (' ' + aAttr + '="' + ASX_chkNull(eval('aObj.' + aAttr + ASX_SUFFIX)) +'"'); 
	}
	rtxt += '>';
	/* handle textNode */
	rtxt += ASX_chkNull(aObj.txt);
	/* handle elements */
	var aSubNode = null;
	var aSubObj = null;
	for (var i=0; i<aObj.elems_seq.length-1; i++) {		// ŏIvfdummy
		aSubNode = aObj.elems_seq[i];
		aSubObj = eval("aObj." + aSubNode + ASX_SUFFIX);
		//rtxt += ("*" + aElem + "*");
		if (ASX_inArray(aObj.uni_elems, aSubNode)) {
			rtxt += this.marshal_node(aSubObj, aSubNode);
		} else {
			for (var j=0; j<aSubObj.length; j++) {
				rtxt += this.marshal_node(aSubObj[j], aSubNode);
			}
		}
	}
	/* close node */
	rtxt += '</' + aNode + '>';
	
	return rtxt;
}
